package barrier;

import java.util.*;

public class Main
implements Runnable
{
	static Random r;
	BarrierSync bs;
	net.IntHolder ih;
	BooleanHolder bh;

	public static void main(String[] argv)
	{
		Main m = new Main();
		m.exec(argv);
	}

	public void exec(String[] argv)
	{
		int k = 10;
		if(argv.length > 0)
		{
			k = Integer.parseInt(argv[0]);
		}
		for(int i = 0;i<k;i++)
		{
			(new Thread(this)).start();
		}

		synchronized(ih)
		{
			while(ih.value < k)
			{
				try
				{
					ih.wait();
				}
				catch(InterruptedException ie)
				{
				}
			}
		}

		//inizializza la barriera
		bs.init();

		synchronized(bh)
		{
			bh.value = true;
			bh.notifyAll();
		}
	}

	public Main()
	{
		bs = new BarrierSync();
		ih = new net.IntHolder();
		ih.value = 0;
		bh = new BooleanHolder(false);
	}

	public void run()
	{
		String name = Thread.currentThread().getName();
		bs.register();
		synchronized(ih)
		{
			ih.value++;
			ih.notify();
		}

		synchronized(bh)
		{
			while(!bh.value)
			{
				try
				{
					bh.wait();
				}
				catch(InterruptedException ie)
				{
				}
			}
		}

		while(true)
		{
			int attesa = 0;
			attesa = r.nextInt(3000);
			System.out.println("Thread " + name + " attende " + attesa + " millisecondi");
			if(name.equals("Thread-1"))
			{
			}
			else
			{
				try
				{
					Thread.sleep(attesa);
				}
				catch(InterruptedException ie)
				{
				}
			}
			System.out.println("Thread " + name + " sync");
			bs.sync();
			System.out.println("Thread " + name + " sync done, reloop");
		}
	}

	static
	{
		r = new Random(System.currentTimeMillis());
	}
}
