package locks;

import java.util.*;

// forniamo la lista numerabile di Thread dentro la sezione critica con il supporto nativo di Java
public class MyLockSync
{
	private List<Thread> lockers = new LinkedList<Thread>();
	private int max = 0;

	public MyLockSync(int i)
	{
		max = i;
	}

	public boolean lock()
	{
		//synchronized(lockers)
		synchronized(this)
		{
			//devo controllare ogni volta, anche appena svegliato
			while(lockers.size() >= max)//non posso entrare, devo aspettare
			{
				try
				{
					this.wait();
				}
				catch(InterruptedException ie)
				{
					ie.printStackTrace();
				}
			}
			//se arrivo qui sono sicuro che nella sezione critica ci sono meno di max Thread
			lockers.add(Thread.currentThread());
		}
		return true;
	}

	public boolean unlock()
	{
		boolean retval = false;
		//synchronized(lockers)
		synchronized(this)
		{
			retval = lockers.remove(Thread.currentThread());
			if(retval)
			{
				this.notify();
			}
		}
		return retval;
	}
}
