package net;

import java.io.*;
import java.net.*;
import java.util.*;
import java.util.concurrent.atomic.*;

public class ClientTCP3
implements Runnable
{
	Socket s = null;
	ObjectInputStream ois = null;
	ObjectOutputStream oos = null;
	static AtomicLong al = new AtomicLong(Long.MIN_VALUE);
	Map<Long, Busta> resultTab;

	public ClientTCP3(int port) throws IOException
	{
		this(port, "localhost");
	}

	public ClientTCP3(int port , String host) throws IOException
	{
		s = new Socket(host, port);
	}

	public ClientTCP3() throws IOException
	{
		this(1234);
	}

	public ClientTCP3(Socket theS) throws InstantiationException
	{
		if(theS == null)
		{
			throw new InstantiationException("Non posso usare null come parametro di costruzione");
		}
		s = theS;
	}

	public void openStreams() throws IOException
	{
		resultTab = new HashMap<Long, Busta>();
		oos = new ObjectOutputStream(s.getOutputStream());
		ois = new ObjectInputStream(s.getInputStream());
		(new Thread(this)).start();
	}

	public static void main(String[] argv) throws IOException, ClassNotFoundException
	{
		String host = "localhost";
		int port = 1234;
		Scanner stdin = null;

		if(argv.length > 0)
		{
			port = Integer.parseInt(argv[0]);
		}
		if(argv.length > 1)
		{
			host = argv[1];
		}
		ClientTCP3 cl = new ClientTCP3(port, host);
		cl.openStreams();
		stdin = new Scanner(System.in);
		cl.comLoop(stdin);
	}

	public Object submit(Object o) throws IOException, ClassNotFoundException
	{
		Busta b = new Busta();
		b.id = al.getAndIncrement();
		b.payload = o;
		try
		{
			synchronized(b)
			{
				synchronized(resultTab)
				{
					resultTab.put(b.id, b);
				}
				synchronized(oos)
				{
					oos.writeObject(b);
					oos.flush();
				}
				try
				{
					b.wait();
				}
				catch(InterruptedException ie)
				{
					ie.printStackTrace();
				}
			}

			return b.payload;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			try
			{
				ois.close();
				oos.close();
				s.close();
			}
			catch(IOException ioe2)
			{
				ioe2.printStackTrace();
			}
			throw ioe;
		}
	}

	public void comLoop(Scanner stdin) throws IOException, ClassNotFoundException
	{
		System.out.print("Cosa vuoi dire al server? >");
		try
		{
			while(stdin.hasNextLine())
			{
				String line = stdin.nextLine();
				oos.writeObject(line);
				oos.flush();
				System.out.println("Il server mi risponde <" + ois.readObject() + ">");
				System.out.print("Cosa vuoi dire al server? >");
			}
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			ioe.printStackTrace();
			try
			{
				ois.close();
				oos.close();
				s.close();
			}
			catch(IOException ioe2)
			{
				ioe2.printStackTrace();
			}
			throw ioe;
		}
	}

	public void run()
	{
		while(true)
		{
			Busta b = null;
			try
			{
				b = (Busta)ois.readObject();
			}
			catch(IOException ioe)
			{
				ioe.printStackTrace();
				System.exit(1);
			}
			catch(ClassNotFoundException cnfe)
			{
				cnfe.printStackTrace();
				System.exit(1);
			}
			Busta b2 = resultTab.get(b.id);
			synchronized(b2)
			{
				b2.payload = b.payload;
				b2.notify();
			}
		}
	}
}
