package net;

import java.net.*;
import java.io.*;
import java.util.*;

public class ServerTCP
implements Runnable
{
	ServerSocket ss = null;
	boolean goOn;

	private sockCount = 0;
	private servantCount = 0;

	List<Socket> socks;

	public ServerTCP(int port) throws IOException
	{
		ss = new ServerSocket(port);
		goOn = true;
		socks = new LinkedList<Socket>();
		for(int i = 0;i<1;i++)
		{
			(new Thread(this)).start();
			synchronized(this)
			{
				servantCount++;
			}
		}
	}

	public ServerTCP() throws IOException
	{
		this(1234);
	}

	public void stop()
	{
		goOn = false;
	}

	public void listenAndAccept()
	{
		while(goOn)
		{
			Socket s = null;
			try
			{
				s = ss.accept();
				synchronized(socks)
				{
					socks.add(s);
					socks.notify();
				}

				Thread.yield();

				synchronized(socks)
				{
					if(socks.size() > 0)
					{
						(new Thread(this)).start();
					}
				}
			}
			catch(IOException ioe)
			{
				ioe.printStackTrace();
				System.exit(1);
			}
		}
	}

	public void run()
	{
		System.out.println("Thread " + Thread.currentThread().getName() + " starts");
		while(true)
		{
			Socket s = null;
			synchronized(socks)
			{
				while(socks.isEmpty())
				{
					try
					{
						socks.wait();
					}
					catch(InterruptedException ie)
					{
						ie.printStackTrace();
					}
				}
				s = socks.remove(0);
				System.out.println("Thread " + Thread.currentThread().getName() + " connessione");
			}

			try
			{
				InputStream is = s.getInputStream();
				OutputStream os = s.getOutputStream();
				PrintWriter pw = new PrintWriter(os);
				Scanner scan = new Scanner(is);

				while(scan.hasNextLine())
				{
					String line = scan.nextLine();
					System.out.println("Mi hanno detto <" + line + ">");
					pw.println("Ho capito");
					pw.flush();
				}
			}
			catch(IOException ioe)
			{
				ioe.printStackTrace();
			}
			finally
			{
				try
				{
					s.close();
				}
				catch(IOException ioe2)
				{
					ioe2.printStackTrace();
					System.exit(1);
				}
			}
			System.out.println("Thread " + Thread.currentThread().getName() + " chiusa connessione");
		}
	}

	public static void main(String[] argv) throws IOException
	{
		int port = 1234;

		if(argv.length > 0)
		{
			port = Integer.parseInt(argv[0]);
		}

		(new ServerTCP(port)).listenAndAccept();
	}
}
