package reflect;

import java.lang.reflect.*;
import java.util.Scanner;

public class Factory
{
	public static final String interfacciaBase = "reflect.Quadrilatero";

	public Quadrilatero getQuadrilatero(String type, Scanner input) throws ClassNotFoundException, InstantiationException, IllegalAccessException
	{
		Boolean tipoCorretto = false;
		Class clazz = Class.forName(type);

		Class[] interf = clazz.getInterfaces();
		for(int i = 0;i<interf.length;i++)
		{
			if(interfacciaBase.equals(interf[i].getName()))
			{
				//stesso nome -> ok
				tipoCorretto = true;
				break;
			}
		}
		if(!tipoCorretto)
		{
			throw new IllegalArgumentException("Classe " + clazz.getName() + " non e' un " + interfacciaBase);
		}

		Quadrilatero q = (Quadrilatero)clazz.newInstance();
		q.popolaAttributi(input);

		return q;
	}

	public static void main(String[] argv)
	{
		Scanner stdin = new Scanner(System.in);
		Factory f = new Factory();
		while(true)
		{
			try
			{
				System.out.print("Nome della classe ? > ");
				Quadrilatero q = f.getQuadrilatero(stdin.nextLine(), stdin);
				System.out.println(q);
			}
			catch(ClassNotFoundException | InstantiationException | IllegalAccessException | IllegalArgumentException exc)
			{
				exc.printStackTrace();
			}
		}
	}
}
