package reflect;

import java.lang.reflect.*;
import java.util.*;

public class ParametricFactory<T>
{
	public static final String interfacciaBase = "reflect.Popolabile";
	//public static final String interfacciaBase = T.getClass().getName();

	public T getInstance(String type, Scanner input) throws ClassNotFoundException, InstantiationException, IllegalAccessException
	{
		Boolean tipoCorretto = false;
		Class clazz = Class.forName(type);

		List<Class> lista = new ArrayList<Class>();
		Class[] interf = clazz.getInterfaces();
		for(int i = 0;i<interf.length;i++)//appendo tutte le interfacce di primo livello
		{
			lista.add(interf[i]);
		}

		while(!lista.isEmpty())
		{
			Class c = lista.remove(0);
			System.out.println(c.getName());
			if(interfacciaBase.equals(c.getName()))
			{
				//stesso nome -> ok
				tipoCorretto = true;
				break;
			}
			interf = c.getInterfaces();
			for(int i = 0;i<interf.length;i++)
			{
				lista.add(interf[i]);
			}
		}
		if(!tipoCorretto)
		{
			throw new IllegalArgumentException("Classe " + clazz.getName() + " non e' un " + interfacciaBase);
		}

		//T q = (T)clazz.newInstance();
		Object o = clazz.newInstance();
		T q = null;
		try
		{
			q = (T)o;
		}
		catch(ClassCastException cce)
		{
			IllegalArgumentException t = new IllegalArgumentException("Tipo " + type + " non compatibile");
			t.initCause(cce);
			throw t;
		}
		((reflect.Popolabile)q).popolaAttributi(input);

		return q;
	}

	public static void main(String[] argv)
	{
		Scanner stdin = new Scanner(System.in);
		ParametricFactory<Quadrilatero> f = new ParametricFactory<Quadrilatero>();
		while(true)
		{
			try
			{
				System.out.print("Nome della classe ? > ");
				Quadrilatero q = f.getInstance(stdin.nextLine(), stdin);
				System.out.println(q);
			}
			catch(ClassNotFoundException | InstantiationException | IllegalAccessException | IllegalArgumentException exc)
			{
				exc.printStackTrace();
			}
		}
	}
}
