package request;

import arithmetic.Operation;
import java.util.Map;
import java.util.concurrent.locks.Lock;


public class ArithmeticExecutor implements Runnable
{
    private Operation op;
    private Map<Key, Result> results;
    private Key key;
    private Lock resultsLock;

    public ArithmeticExecutor(Operation op, Key key, Map<Key, Result> results,
            Lock resultsLock)
    {
        this.op = op;
        this.results = results;
        this.key = key;
        this.resultsLock = resultsLock;
    }

    @Override
    public void run()
    {
        Result res = new Result(op.resolve());
        resultsLock.lock();
        try
        {
            results.put(key, res);
            key.getCondition().signalAll(); // sveglia tutti i Thread in attesa su questa chiave
        }
        finally
        {
            resultsLock.unlock();
        }
    }   
}
